#include "ofApp.h"

//--------------------------------------------------------------
void ofApp::setup(){
    myImage.load("photo.jpg");
    grayPixels.allocate(myImage.getWidth(),myImage.getHeight(), OF_IMAGE_GRAYSCALE);
    colorPixels.allocate(myImage.getWidth(),myImage.getHeight(), OF_IMAGE_COLOR);
    imageWidth=myImage.getWidth();
}

//--------------------------------------------------------------
void ofApp::update(){
    pixels=myImage.getPixels();
    for(int y=0;y<myImage.getHeight();y++){
        for(int x=0;x<myImage.getWidth();x++){
            ofColor myColor=pixels.getColor(x, y);
            ofColor gray;
            //mix colors manually to greyscale or get automatically
            //gray.set((myColor.r*0.33)+(myColor.g*0.33)+(myColor.b*0.33));
            gray=myColor.getBrightness();
            grayPixels.setColor(x,y,gray);
            colorPixels.setColor(x,y,myColor);
        }
    }
}

//--------------------------------------------------------------
void ofApp::draw(){
    ofSetColor(255);
    myImage.draw(0,0);
    for(int y=0;y<myImage.getHeight();y++){
        for(int x=0;x<myImage.getWidth();x++){
            //METHOD 1. map grayscale to circle radius
            ofSetColor(255,50);
            ofDrawCircle(x+400,y,grayPixels[y*imageWidth+x]/100);
            //METHOD 2. map grayscale to circle color
            ofSetColor(grayPixels[y*imageWidth+x]);
            ofDrawCircle(x+400,y+350,1);
            //METHOD 3. map color to colored circles
            //one channel: ofSetColor(colorPixels.getColor(x,y).r);
            ofSetColor(colorPixels.getColor(x,y),100);
            ofDrawCircle(x,y+350,10);

        }
    }
}

//--------------------------------------------------------------
void ofApp::keyPressed(int key){

}

//--------------------------------------------------------------
void ofApp::keyReleased(int key){

}

//--------------------------------------------------------------
void ofApp::mouseMoved(int x, int y){

}

//--------------------------------------------------------------
void ofApp::mouseDragged(int x, int y, int button){

}

//--------------------------------------------------------------
void ofApp::mousePressed(int x, int y, int button){

}

//--------------------------------------------------------------
void ofApp::mouseReleased(int x, int y, int button){

}

//--------------------------------------------------------------
void ofApp::mouseEntered(int x, int y){

}

//--------------------------------------------------------------
void ofApp::mouseExited(int x, int y){

}

//--------------------------------------------------------------
void ofApp::windowResized(int w, int h){

}

//--------------------------------------------------------------
void ofApp::gotMessage(ofMessage msg){

}

//--------------------------------------------------------------
void ofApp::dragEvent(ofDragInfo dragInfo){ 

}
